import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class GUICalculator extends JFrame {

	private JPanel buttonPanel;
	private JButton add;
	private JButton subtract;
	private JButton multiply;
	private JButton divide;
	private JButton equals;
	private JButton one;
	private JButton two;
	private JButton three;
	private JButton four;
	private JButton five;
	private JButton six;
	private JButton seven;
	private JButton eight;
	private JButton nine;
	private JButton zero;

	private JPanel resultsPanel;
	private JTextField results;

	private int result;
	private int tempNum;
	private String queuedCommand;
	private boolean overrideNum;

	public GUICalculator() {

		setLayout(new BorderLayout());
		init();

		setTitle("Calculator");
		setSize(new Dimension(400, 200));
		setResizable(false);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);
	}

	private void init() {
		result = 0;
		queuedCommand = "";
		overrideNum = true;
		tempNum = 0;
		
		ButtonListener bListener = new ButtonListener();
		add = new JButton("+");
		subtract = new JButton("-");
		multiply = new JButton("*");
		divide = new JButton("/");
		equals = new JButton("=");
		one = new JButton("1");
		two = new JButton("2");
		three = new JButton("3");
		four = new JButton("4");
		five = new JButton("5");
		six = new JButton("6");
		seven = new JButton("7");
		eight = new JButton("8");
		nine = new JButton("9");
		zero = new JButton("0");
		add.addActionListener(bListener);
		subtract.addActionListener(bListener);
		multiply.addActionListener(bListener);
		divide.addActionListener(bListener);
		equals.addActionListener(bListener);
		one.addActionListener(bListener);
		two.addActionListener(bListener);
		three.addActionListener(bListener);
		four.addActionListener(bListener);
		five.addActionListener(bListener);
		six.addActionListener(bListener);
		seven.addActionListener(bListener);
		eight.addActionListener(bListener);
		nine.addActionListener(bListener);
		zero.addActionListener(bListener);
		
		buttonPanel = new JPanel();
		buttonPanel.setLayout(new GridLayout(4, 4));

		results = new JTextField("0");
		results.setColumns(25);
		results.setHorizontalAlignment(JTextField.RIGHT);
		results.setEditable(false);
		resultsPanel = new JPanel();
		resultsPanel.setLayout(new FlowLayout());
		resultsPanel.add(results);

		buttonPanel.add(one);
		buttonPanel.add(two);
		buttonPanel.add(three);
		buttonPanel.add(add);
		buttonPanel.add(four);
		buttonPanel.add(five);
		buttonPanel.add(six);
		buttonPanel.add(subtract);
		buttonPanel.add(seven);
		buttonPanel.add(eight);
		buttonPanel.add(nine);
		buttonPanel.add(multiply);
		buttonPanel.add(new JLabel()); //we want an empty spot
		buttonPanel.add(zero);
		buttonPanel.add(equals);
		buttonPanel.add(divide);

		add(resultsPanel, BorderLayout.NORTH);
		add(buttonPanel, BorderLayout.CENTER);
	}

	class ButtonListener implements ActionListener {

		public void actionPerformed(ActionEvent evt) {
			// Get label of the button clicked in event passed in
			String arg = evt.getActionCommand();
			if (arg.equals("1") || arg.equals("2") || arg.equals("3") ||
					arg.equals("4") || arg.equals("5") || arg.equals("6") ||
					arg.equals("7") || arg.equals("8") || arg.equals("9") ||
					arg.equals("0")) {
				
					if (overrideNum) {
						results.setText(arg);
						overrideNum = false;
					}
					else {
						results.setText(results.getText() + arg);
					}				
			} else if (arg.equals("+") || arg.equals("-") || arg.equals("*") ||
					arg.equals("/")) {
				if (queuedCommand.equals("+")){
					tempNum = tempNum + Integer.parseInt(results.getText());
				}
				else if (queuedCommand.equals("-")){
					tempNum = tempNum - Integer.parseInt(results.getText());
				}
				else if (queuedCommand.equals("*")){
					tempNum = tempNum * Integer.parseInt(results.getText());
				}
				else if (queuedCommand.equals("/")){
					tempNum = tempNum / Integer.parseInt(results.getText());
				}
				else {
					tempNum = Integer.parseInt(results.getText());
				}
				queuedCommand = arg;
				overrideNum = true;
			} else if (arg.equals("=")) {
				if (queuedCommand.equals("+")){
					result = tempNum + Integer.parseInt(results.getText());
				}
				else if (queuedCommand.equals("-")){
					result = tempNum - Integer.parseInt(results.getText());
				}
				else if (queuedCommand.equals("*")){
					result = tempNum * Integer.parseInt(results.getText());
				}
				else if (queuedCommand.equals("/")){
					result = tempNum / Integer.parseInt(results.getText());
				}
				queuedCommand = "";
				
				results.setText(String.valueOf(result));
				overrideNum = true;
			}
		}
	}

	public static void main(String[] args) {
		new GUICalculator();
	}

}
